# Non-fungible token (NFT)

The NFT stream provides updates about newly created or updated NFTs. CSPR.cloud keeps track of NFTs compatible with the [CEP-47](https://github.com/casper-ecosystem/casper-nft-cep47) and [CEP-78](https://github.com/casper-ecosystem/cep-78-enhanced-nft) Casper Network standards.

```
GET /nft-tokens
```

## Optional properties

None

## Query params

| Property                | Type     | Description                                  |
| ----------------------- | -------- | -------------------------------------------- |
| `contract_package_hash` | `string` | Comma-separated contract package hashes      |
| `owner_hash`            | `string` | Comma-separated list of owner account hashes |

## Events

| Event     | Description                                        |
| --------- | -------------------------------------------------- |
| `created` | Notifies about new NFT being minted on the network |
| `updated` | Notifies about an existing NFT being updated       |

## Response

[`WebSocketMessage`](https://docs.cspr.cloud/1.4.x/reference#format)[`<NFTToken>`](https://docs.cspr.cloud/1.4.x/rest-api/non-fungible-token#properties)

## Example

```bash
wscat -c 'wss://streaming.testnet.cspr.cloud/nft-tokens?contract_package_hash=5341882bae97a7368cdb007faa9f25735d2780d601114f82907fd83af2e9f508' \
  -H 'authorization: 55f79117-fc4d-4d60-9956-65423f39a06a'
```

```json
{
  "data": {
    "contract_package_hash": "5341882bae97a7368cdb007faa9f25735d2780d601114f82907fd83af2e9f508",
    "token_id": "119",
    "tracking_id": 1,
    "token_standard_id": 1,
    "owner_type": 0,
    "owner_hash": "66b1b6b393e5aed08be0759d52c484ba2921c844cc0918d5b8bb02849bb833d4",
    "onchain_metadata": {
      "beneficiary": "dd59f6febe111e1e9dd688689523482a0e64906a83df29b5da733235b4da2c79",
      "beneficiaryPercentage": "100",
      "campaign": "12",
      "collection": "21",
      "collectionName": "Bucha City  Ukraine",
      "creatorName": "Olga Litvinenko ",
      "creatorPercentage": "0",
      "currency": "CSPR",
      "description": "test 27 dec",
      "hasReceipt": "false",
      "image": "https://vinfts.mypinata.cloud/ipfs/bafybeidtih6cyguanlx4dgzk6mce5pzjrxpenjjc3earuqjssgnc2nhhru/0.jpg",
      "isForSale": "true",
      "price": "20",
      "sdgs_ids": "3,4,5",
      "title": "Teacher "
    },
    "offchain_metadata": null,
    "offchain_metadata_status": 0,
    "is_burned": false,
    "timestamp": "2023-12-27T16:50:13.689Z"
  },
  "action": "created",
  "extra": {
    "deploy_hash": "f7da222b5b2466b7677c3046f50a40f9be478acf53a345135b32196905407c42"
  },
  "timestamp": "2024-02-07T10:21:29.557865809Z"
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cspr.cloud/1.4.x/streaming-api/non-fungible-token.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
